## vecgeom 1.2.0+dfsg

=== CMakeLists.txt ===
# - Setup the project
cmake_minimum_required(VERSION 3.16...3.22)

include(cmake/modules/RecordCmdLine.cmake)
include(ExternalProject)

project(VecGeom
  VERSION 1.2.0
  DESCRIPTION "Vectorized geometry library for particle-detector simulation"
  HOMEPAGE_URL "https://gitlab.cern.ch/VecGeom/VecGeom"
  LANGUAGES C CXX)

################################################################################
# - Core CMake settings
# - Core/Custom modules
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake/modules)
include(MacroUtilities)
include(CMakeDependentOption)
include(IntelCompileFeatures)

# - Though we check for some absolute paths, ensure there are no others
set(CMAKE_ERROR_ON_ABSOLUTE_INSTALL_DESTINATION ON)

# - Never export to or search in user/system package registry
set(CMAKE_EXPORT_NO_PACKAGE_REGISTRY ON)
set(CMAKE_FIND_PACKAGE_NO_PACKAGE_REGISTRY ON)
set(CMAKE_FIND_PACKAGE_NO_SYSTEM_PACKAGE_REGISTRY ON)

# - Force project directories to appear first in any list of includes
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

# - Only relink shared libs when interface changes
set(CMAKE_LINK_DEPENDS_NO_SHARED ON)

# - Only report newly installed files
set(CMAKE_INSTALL_MESSAGE LAZY)

################################################################################
# - Core build settings
if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "No build type selected, default to Release")
  set(CMAKE_BUILD_TYPE "Release")
endif()

# - Store CompilerId as a boolean for convenience
set("${CMAKE_CXX_COMPILER_ID}" TRUE)
if(NOT GNU AND NOT Clang AND NOT AppleClang AND NOT Intel AND NOT IntelLLVM)
  message(WARNING "Unsupported C++ compiler '${CMAKE_CXX_COMPILER_ID}', build will likely fail.")
endif()

# - C++ standard and extensions
if(CMAKE_CXX_STANDARD LESS 17)
  message(FATAL_ERROR "VecGeom requires at least C++17")
endif()
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17 CACHE STRING "C++ ISO Standard")
set(CMAKE_CXX_STANDARD_REQUIRED True)

# Use ccache if available ( to avoid recompilation on branch switches )
find_program(CCACHE_PROGRAM ccache)
mark_as_advanced(CCACHE_PROGRAM)
if(CCACHE_PROGRAM)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif()

# - Basic library settings
# Build statics with Position Independent Code
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Install paths
include(GNUInstallDirs)
# Add a path for CMake config files (immutable)
set(CMAKE_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake")
set(CMAKE_INSTALL_FULL_CMAKEDIR "${CMAKE_INSTALL_FULL_LIBDIR}/cmake")

# Add uninstall target if required
if(NOT TARGET uninstall)
  configure_file(cmake/cmake_uninstall.cmake.in
    "${PROJECT_BINARY_DIR}/cmake_uninstall.cmake"
    @ONLY)

  add_custom_target(uninstall
    COMMAND "${CMAKE_COMMAND}" -P "${PROJECT_BINARY_DIR}/cmake_uninstall.cmake"
    WORKING_DIRECTORY "${PROJECT_BINARY_DIR}")
endif()

################################################################################
# Configuration options
# - ISA
set(VECGEOM_ISAS empty)
if(CMAKE_SYSTEM_PROCESSOR MATCHES "(i686|x86_64)")
  set(VECGEOM_ISAS sse2 sse3 ssse3 sse4.1 sse4.2 avx avx2 native empty)
endif()

enum_option(VECGEOM_VECTOR DOC "Vector instruction set to be used"
  TYPE STRING
  VALUES ${VECGEOM_ISAS}
  CASE_INSENSITIVE)

# - ISA Backend
set(VECGEOM_BACKENDS scalar vc)
enum_option(VECGEOM_BACKEND DOC "Vector backend API to be used"
  TYPE STRING
  VALUES ${VECGEOM_BACKENDS}
  CASE_INSENSITIVE)

# Case adjustment because pass to VecCore components is
if(VECGEOM_BACKEND STREQUAL "scalar")
  set(VECGEOM_BACKEND "Scalar")
elseif(VECGEOM_BACKEND STREQUAL "vc")
  set(VECGEOM_BACKEND "Vc")
endif()

# Configure backend for export to VecGeom's Config.h and setting up VecCore
string(TOUPPER "${VECGEOM_BACKEND}" _BACKEND_UP)
set(VECGEOM_${_BACKEND_UP} True)
message(STATUS "Configuring with ${VECGEOM_BACKEND} backend")

if("${VECGEOM_BACKEND}" STREQUAL "Vc")
  set(VecCore_COMPONENTS ${VecCore_COMPONENTS} ${VECGEOM_BACKEND})
endif()

# - Core
option(VECGEOM_BUILTIN_VECCORE "Build VecCore and its dependencies from source" OFF)
# Check/Store an internal variable to check if we switch between builtin/external
# - If we switch from builtin -> external, then we must reset VecCore_DIR later.
# State might have changed...
if(NOT (__BUILTIN_VECCORE_LAST STREQUAL VECGEOM_BUILTIN_VECCORE))
  if(NOT VECGEOM_BUILTIN_VECCORE)
    set(__BUILTIN_VECCORE_DISABLED ON)
  endif()
endif()
set(__BUILTIN_VECCORE_LAST ${VECGEOM_BUILTIN_VECCORE} CACHE INTERNAL "Builtin VecCore marker")

# - Precision
option(VECGEOM_SINGLE_PRECISION "Use single precision floating point type throughout VecGeom" OFF)

option(VECGEOM_ENABLE_CUDA "Enable compilation for CUDA." OFF)
cmake_dependent_option(VECGEOM_CUDA_VOLUME_SPECIALIZATION "Use specialized volumes for CUDA." OFF "VECGEOM_ENABLE_CUDA" OFF)

if(VECGEOM_ENABLE_CUDA)
  enable_language(CUDA)
  # Keep these checks coherent with the C++ compiler/standard
  if(CMAKE_CUDA_COMPILER_ID STREQUAL "NVIDIA")
    if(CMAKE_CUDA_COMPILER_VERSION VERSION_LESS 11)
      message(FATAL_ERROR "CUDA 11 or newer required, found '${CMAKE_CUDA_COMPILER_VERSION}'")
    endif()
  else()
    message(WARNING "Unsupported CUDA compiler '${CMAKE_CUDA_COMPILER_VERSION}', build will likely fail")
  endif()
  set(VecCore_COMPONENTS ${VecCore_COMPONENTS} "CUDA")
endif()

option(VECGEOM_NO_SPECIALIZATION "Disable specialization of volumes." ON)
option(VECGEOM_PLANESHELL "Enable the use of PlaneShell class for the trapezoid." ON)
option(VECGEOM_QUADRILATERAL_ACCELERATION "Enable SIMD vectorization when looping over quadrilaterals (in Polyhedron)." ON)
option(VECGEOM_DISTANCE_DEBUG "Enable comparison of calculated distances againt ROOT/Geant4 behind the scenes" OFF)
option(VECGEOM_INPLACE_TRANSFORMATIONS "Put transformation as members rather than pointers into PlacedVolume objects" ON)
option(VECGEOM_USE_CACHED_TRANSFORMATIONS "Use cached transformations in navigation states" OFF)
option(VECGEOM_USE_INDEXEDNAVSTATES "Use indices rather than volume pointers in NavigationState objects" ON)

option(VECGEOM_USE_NAVINDEX "Use navigation index table and states" OFF)
if((NOT VECGEOM_USE_NAVINDEX) AND VECGEOM_ENABLE_CUDA)
  message(STATUS "Forcing VECGEOM_USE_NAVINDEX to ON (required by VECGEOM_ENABLE_CUDA=ON)")
  set(VECGEOM_USE_NAVINDEX ON CACHE BOOL "Use navigation index table and states" FORCE)
endif()

option(VECGEOM_GDML "Enable GDML persistency. Requires Xerces-C" OFF)
option(VECGEOM_GDMLDEBUG "Enable additional debug information in GDML module" OFF)

option(VECGEOM_EMBREE "Enable Intel Embree" OFF)

option(VECGEOM_FAST_MATH "Enable the -ffast-math compiler option in Release builds" OFF)

################################################################################
# - Testing, unit, coverage, benchmarking, validation etc
include(CTest)

# ROOT/Geant4 options are strictly testing only, but the APIs they expose are in use in the wild.
# We therefore retain names pending proper deprecation of the interfaces.
cmake_dependent_option(VECGEOM_ROOT "Enable testing using ROOT" OFF "BUILD_TESTING" OFF)
cmake_dependent_option(VECGEOM_GEANT4 "Enable testing using Geant4" OFF "BUILD_TESTING" OFF)

cmake_dependent_option(VECGEOM_TEST_BENCHMARK "Enable benchmark/performance tests" OFF "BUILD_TESTING" OFF)
cmake_dependent_option(VECGEOM_TEST_VALIDATION "Enable validation tests from CMS geometry" OFF "BUILD_TESTING" OFF)

# Static tests build/use clang-tidy, so require compile commands for VecGeom to be exported
cmake_dependent_option(VECGEOM_TEST_STATIC_ANALYSIS "Enable static analysis tests on VecGeom" OFF "BUILD_TESTING" OFF)
if(VECGEOM_TEST_STATIC_ANALYSIS)
  set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
endif()

# Thought to now be obsolete 
cmake_dependent_option(VECGEOM_TEST_VTUNE "Enable use of Intel Vtune for profiling tests" OFF "BUILD_TESTING" OFF)

# TODO: not completely set up. Will build VG+tests with correct flags/links, but no report gen.
cmake_dependent_option(VECGEOM_TEST_COVERAGE "Enable coverage testing flags" OFF "BUILD_TESTING" OFF)


################################################################################
# Minimum version of VecCore we need.
set(VecCore_VERSION "0.8.0")

# Enable/Disable build/use of builtin veccore
if(VECGEOM_BUILTIN_VECCORE)
  include(BuiltinVecCore)
elseif(__BUILTIN_VECCORE_DISABLED)
  # Unset VecCore_DIR if it points inside our build directory
  string(FIND "${VecCore_DIR}" "${PROJECT_BINARY_DIR}" __vcd_is_builtin)
  if(__vcd_is_builtin EQUAL 0)
    unset(VecCore_DIR CACHE)
  endif()
endif()

# Find VecCore with selected components turned on (CUDA and backend)
find_package(VecCore ${VecCore_VERSION} REQUIRED COMPONENTS ${VecCore_COMPONENTS})
set(VECGEOM_LIBRARIES_EXTERNAL ${VECGEOM_LIBRARIES_EXTERNAL} VecCore::VecCore)

################################################################################
# - C++ Compiler Flags/Settings for each build type
# Done after all options, as flags are dependent on chosen ISA
# Flags will also be forwarded by CUDA when compiling C++.
set(VECGEOM_ERROR_LIMIT 20 CACHE STRING "Limit number of errors output by compiler")
mark_as_advanced(VECGEOM_ERROR_LIMIT)

if(GNU)
  string(APPEND VECGEOM_CXX_FLAGS " -Wall -fmax-errors=${VECGEOM_ERROR_LIMIT}")

  if(CMAKE_BUILD_TYPE MATCHES Debug)
     string(APPEND VECGEOM_CXX_FLAGS " -ggdb -O0")
  else()
    string(APPEND VECGEOM_CXX_FLAGS " -ftree-vectorize -finline-limit=10000000")
    if(VECGEOM_FAST_MATH)
      string(APPEND VECGEOM_CXX_FLAGS " -ffast-math")
    endif()
  endif()

  if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL "7")
    string(APPEND VECGEOM_COMPILATION_FLAGS " -faligned-new")
  endif()

elseif(Intel)
  string(APPEND VECGEOM_CXX_FLAGS " -Wall -fmax-errors=${VECGEOM_ERROR_LIMIT}")

  if(CMAKE_BUILD_TYPE MATCHES Debug)
    string(APPEND VECGEOM_CXX_FLAGS " -ggdb -O0")
  else()
    string(APPEND VECGEOM_CXX_FLAGS " -fno-alias")
  endif()

  if(NOT VECGEOM_FAST_MATH)
    string(VECGEOM_CXX_FLAGS " -fp-model precise")
  endif()

elseif(IntelLLVM)
  string(APPEND VECGEOM_CXX_FLAGS " -Wall -fmax-errors=${VECGEOM_ERROR_LIMIT}")

  if(CMAKE_BUILD_TYPE MATCHES Debug)
    string(APPEND VECGEOM_CXX_FLAGS " -ggdb -O0")
  endif()

  if(VECGEOM_FAST_MATH)
    string(APPEND VECGEOM_CXX_FLAGS " -ffast-math")
    string(APPEND VECGEOM_CXX_FLAGS " -Wno-tautological-compare")
  else()
    string(APPEND VECGEOM_CXX_FLAGS " -fno-fast-math")
  endif()

elseif(Clang OR AppleClang)
  string(APPEND VECGEOM_CXX_FLAGS " -Wall -ferror-limit=${VECGEOM_ERROR_LIMIT}")

  if(CMAKE_BUILD_TYPE MATCHES Debug)
    string(APPEND VECGEOM_CXX_FLAGS " -ggdb -O0")
  else()
    string(APPEND VECGEOM_CXX_FLAGS " -ftree-vectorize")
    if(VECGEOM_FAST_MATH)
      string(APPEND VECGEOM_CXX_FLAGS " -ffast-math")
    endif()
  endif()

  if(CMAKE_CXX_COMPILER_VERSION GREATER_EQUAL "4")
    string(APPEND VECGEOM_COMPILATION_FLAGS " -faligned-new")
  endif()
endif()

# - Additional flags for coverage testing support
if(VECGEOM_TEST_COVERAGE)
  if(GNU)
    string(APPEND VECGEOM_CXX_FLAGS " -fprofile-arcs -ftest-coverage")
    set(VECGEOM_LIBRARIES_EXTERNAL ${VECGEOM_LIBRARIES_EXTERNAL} gcov)
  endif()

  if(Clang OR AppleClang)
    string(APPEND VECGEOM_CXX_FLAGS " --coverage")
    set(VECGEOM_LIBRARIES_EXTERNAL ${VECGEOM_LIBRARIES_EXTERNAL} profile_rt)
  endif()

  if(Intel OR IntelLLVM)
    message(FATAL_ERROR "Coverage testing not supported for icc.")
  endif()
endif()

# - ISA-specific flags
string(TOLOWER ${VECGEOM_VECTOR} _arch_lo)
string(TOUPPER ${VECGEOM_VECTOR} _arch_up)

if(${_arch_lo} MATCHES native)
  if(Intel OR IntelLLVM)
    string(APPEND VECGEOM_COMPILATION_FLAGS " -march=native")
  elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(powerpc|ppc)64le")
    string(APPEND VECGEOM_COMPILATION_FLAGS " -mcpu=${_arch_lo} -mtune=${_arch_lo}")
  else()
    string(APPEND VECGEOM_COMPILATION_FLAGS " -march=${_arch_lo}")
  endif()
elseif(NOT ${_arch_lo} MATCHES empty)

=== test/CMakeLists.txt ===
################################################################################
## TESTING
################################################################################
# Helper Macros/Functions

macro(build_executables EXECUTABLES)
  foreach(EXECUTABLE ${EXECUTABLES})
    get_filename_component(TARGET_NAME ${EXECUTABLE} NAME_WE)
    add_executable(${TARGET_NAME} ${EXECUTABLE})
    target_link_libraries(${TARGET_NAME} PUBLIC $<IF:$<BOOL:${VECGEOM_ENABLE_CUDA}>,vecgeomcuda_static,vecgeom>)
  endforeach()
endmacro()

function(add_to_ctest EXECUTABLES)
  foreach(EXECUTABLE ${EXECUTABLES})
    get_filename_component(TARGET_NAME ${EXECUTABLE} NAME_WE)
    add_test(${TARGET_NAME} ${TARGET_NAME})
  endforeach()
endfunction()

# actual function for managing the download
function(DOWNLOAD_IF_NOT_INSTALLED FILE_URL LOCALFILE TARGETPATH MD5HASH )
  set(FILENAME "${TARGETPATH}/${LOCALFILE}")
  if(EXISTS "${FILENAME}")
    file(MD5 "${FILENAME}" MD5ACTUAL)
    if(MD5ACTUAL STREQUAL MD5HASH)
      return()
    else()
      message(WARNING "Hash not correct for data file ${FILENAME}:\n"
        "expected: ${MD5HASH}\n"
        "actual  : ${MD5ACTUAL}\n"
        "Trying to re-download")
    endif()
  endif()

  message(STATUS "Downloading ${LOCALFILE}")
  file(DOWNLOAD ${FILE_URL} ${FILENAME} SHOW_PROGRESS EXPECTED_HASH MD5=${MD5HASH})
endfunction()
################################################################################

################################################################################
# Download data if required
message(STATUS "Checking data files required for tests")
if(VECGEOM_ROOT)
  download_if_not_installed("https://cernbox.cern.ch/index.php/s/pn2UkCtloi7i0xy/download"
    "cms2015.root"
    "${CMAKE_CURRENT_BINARY_DIR}"
    "fb3ede867532b372c5e6f7138d00c07e")
  download_if_not_installed("https://cernbox.cern.ch/index.php/s/dTChF8iKEUQHMxo/download"
    "ExN03.root"
    "${CMAKE_CURRENT_BINARY_DIR}"
    "b6b0cfdd5035117171bfe1b7f1f40c3f")
endif()
################################################################################
# Define executables
################################################################################
# - Dedicated Benchmark tests
if(VECGEOM_TEST_BENCHMARK)
  add_subdirectory(benchmark)
endif()

################################################################################
# - Static Analysis tests
if(VECGEOM_TEST_STATIC_ANALYSIS)
  add_subdirectory(static_analysis)
endif()

################################################################################
# - Core Tests
set(TEST_EXECUTABLES_CORE
  core/TestVoxelHashMap.cpp
  core/SafetyEstimatorTest.cpp
  core/ContainerTest.cpp
  core/create_geometry.cpp
  core/BitSetTest.cpp
  core/PlanesTest.cpp
  core/QuadrilateralTest.cpp
  # core/SOATest.cpp
  core/Transformation3DTest.cpp
  # core/boolminustest.cpp
  # core/boolminustest2.cpp
  core/PhiWedgeTest.cpp
  core/ThetaConeTest.cpp
  core/TestConvexity.cpp
  core/BooleanConvexityTest.cpp
  unit_tests/TestEstimateSurfaceArea.cpp
  unit_tests/TestVecGeomPolycone.cpp
  unit_tests/TestNavStateIndex.cpp
  core/TestSExtru.cpp
  # to be enabled when running cleanly
  unit_tests/TestBooleans.cpp
  core/AssemblyTest.cpp
  core/TestMakeInstance.cpp
  #  services/CompNavStatePools.cpp
  core/TestMaskedAssign.cpp
  core/TestVector.cpp
  core/TestMap.cpp
  core/TestHybridBVH.cpp
  core/TestEarlyReturns.cpp
  core/CreateTessels.cpp
  core/CreateExtruded.cpp
  core/TestGeoManager.cpp)

if(VECGEOM_USE_INDEXEDNAVSTATES)
  list(APPEND TEST_EXECUTABLES_CORE core/TestNavigationState.cpp)
endif()

if(NOT VECGEOM_ENABLE_CUDA)
  list(APPEND TEST_EXECUTABLES_CORE core/testVectorSafety.cpp)
endif()

build_executables("${TEST_EXECUTABLES_CORE}")
add_to_ctest("${TEST_EXECUTABLES_CORE}")

################################################################################
# - ROOT Tests
if(VECGEOM_ROOT)
  set(TEST_EXECUTABLES_ROOT
    core/BoxBoxIntersectionTest.cpp
    core/SplittedABBox.cpp
    core/TestRegions.cpp
    root/root_geometry.cpp
    root/complex_test1.cpp
    root/E03Test.cpp
    root/ImportFromRootFileTest.cpp
    root/ImportTGeoPgon.cpp
    root/TestExportToROOT.cpp
    root/ExitingOrEntering.cpp
    root/AssemblyExample.cpp
    # higher level benchmarks or executables
    globalbenchmarks/LocatePointsBenchmark.cpp
    globalbenchmarks/SafetyKernelBenchmarker.cpp
    globalbenchmarks/NavigationKernelBenchmarker.cpp
    globalbenchmarks/TraceTrack.cpp
    globalbenchmarks/XRayBenchmarkFromROOTFile.cpp
    # ???
    ${PROJECT_SOURCE_DIR}/services/NavigationSpecializerTest.cpp
    ${PROJECT_SOURCE_DIR}/services/LibraryGenerator.cpp)

  if(VECGEOM_TEST_BENCHMARK)
    list(APPEND TEST_EXECUTABLES_ROOT
      root/BenchmarkShapeFromROOTFile.cpp
      root/BenchmarkShapeFromROOTFile_WithVisualization.cpp
      root/CompareDistances.cpp
      root/GenerateSurfacePoints.cpp
      shape_tester/shapeDebug.cpp)
  endif()

  if(VECGEOM_EMBREE)
    list(APPEND TEST_EXECUTABLES_ROOT core/EmbreeManagerTest.cpp)
  endif()

  add_executable(TestNavigationStatePool
    core/TestNavigationStatePool.cpp
    $<$<BOOL:VECGEOM_ENABLE_CUDA>:core/TestNavigationStatePool.cu>)
  target_link_libraries(TestNavigationStatePool PRIVATE $<IF:$<BOOL:${VECGEOM_ENABLE_CUDA}>,vecgeomcuda_static,vecgeom>)
  add_test(NAME TestNavigationStatePool COMMAND TestNavigationStatePool)

  # - separate list for ROOT UNIT tests
  set(TEST_UNITTESTEXECUTABLES_ROOT
    root/complex_test1.cpp
    root/E03Test.cpp
    root/TestExportToROOT.cpp
    root/ImportTGeoPgon.cpp)

  build_executables("${TEST_EXECUTABLES_ROOT}")
  add_to_ctest("${TEST_UNITTESTEXECUTABLES_ROOT}")
endif()

################################################################################
# - Visualization tests
if(VECGEOM_ROOT)
  set(TEST_EXECUTABLES_VISUALIZATION
    visualization/VisualizeTrap.cpp
    visualization/VisualizePolycone.cpp
    visualization/VisualizePolyhedron.cpp
    visualization/VisualizeParboloid.cpp
    visualization/VisualizeCone.cpp
    # visualization/VisualizeTorus.cpp
    visualization/VisualizeTube.cpp
    visualization/VisualizeScaled.cpp
    visualization/DebugTube.cpp
    visualization/DebugPolyhedron.cpp
    visualization/VisualizeSphere.cpp
    visualization/VisualizeGenTrap.cpp
    visualization/VisualizeHype.cpp
    visualization/VisualizeParallelepiped.cpp
    visualization/VisualizeCutTube.cpp
    # visualization/VisualizeExtruded.cpp
    )

  if(NOT VECGEOM_ENABLE_CUDA)
    list(APPEND TEST_EXECUTABLES_VISUALIZATION visualization/VisualizeMultiUnion.cpp)
  endif()

  build_executables("${TEST_EXECUTABLES_VISUALIZATION}")
endif()

################################################################################
# - Shape Tests
set(TEST_EXECUTABLES_SHAPES
  unit_tests/TestBox.cpp
  unit_tests/TestCons.cpp
  unit_tests/TestGenTrap.cpp
  unit_tests/TestTube.cpp
  unit_tests/TestEllipticalTube.cpp
  unit_tests/TestEllipticalCone.cpp
  unit_tests/TestEllipsoid.cpp
  unit_tests/TestCoaxialCones.cpp
  unit_tests/TestGenericPolycone.cpp
  unit_tests/TestHype.cpp
  unit_tests/TestTrd.cpp
  unit_tests/TestTrap.cpp
  unit_tests/TestParallelepiped.cpp
  unit_tests/TestPolycone.cpp
  unit_tests/TestPolyhedra.cpp
  unit_tests/TestTet.cpp
  unit_tests/TestOrb.cpp
  unit_tests/TestSphere.cpp
  unit_tests/TestTorus2.cpp
  unit_tests/TestParaboloid.cpp
  unit_tests/TestReducedPolycone.cpp
  unit_tests/TestUtils3D.cpp)

if(NOT VECGEOM_ENABLE_CUDA)
  list(APPEND TEST_EXECUTABLES_SHAPES
    unit_tests/TestTessellated.cpp
    unit_tests/TestMesh.cpp)
endif()

build_executables("${TEST_EXECUTABLES_SHAPES}")
# add unit tests
add_test(NAME TestBox COMMAND TestBox)
add_test(NAME TestCone COMMAND TestCons)
add_test(NAME TestGenTrap COMMAND TestGenTrap)
add_test(NAME TestHype COMMAND TestHype)
add_test(NAME TestOrb COMMAND TestOrb)
add_test(NAME TestPolycone COMMAND TestPolycone)
add_test(NAME TestPolyhedra COMMAND TestPolyhedra)
add_test(NAME TestParallelepiped COMMAND TestParallelepiped)
add_test(NAME TestParaboloid COMMAND TestParaboloid)
add_test(NAME TestSphere COMMAND TestSphere)
add_test(NAME TestTet COMMAND TestTet)
add_test(NAME TestTrap COMMAND TestTrap)
add_test(NAME TestTrd COMMAND TestTrd)
add_test(NAME TestTube COMMAND TestTube)
if(NOT VECGEOM_ENABLE_CUDA)
  add_test(NAME TestTessellated COMMAND TestTessellated)
endif()

################################################################################
# - CUDA tests
if(VECGEOM_ENABLE_CUDA)
  add_executable(MapTest cuda/MapTest.cpp cuda/MapTest.cu)
  target_link_libraries(MapTest PUBLIC vecgeomcuda_static)
  add_test(NAME MapTest COMMAND MapTest)

  if(VECGEOM_GDML)
    add_executable(BVHTest cuda/BVHTest.cu cuda/BVHTest.cpp )
    add_executable(MapTestClass cuda/MapTestClass.cpp cuda/MapTestClass.cu)
    add_executable(GeometryTest cuda/GeometryTest.cpp cuda/GeometryTest.cu)

    target_link_libraries(BVHTest      PUBLIC vecgeomcuda_static vgdml)
    target_link_libraries(MapTestClass PUBLIC vecgeomcuda_static vgdml)
    target_link_libraries(GeometryTest PUBLIC vecgeomcuda_static vgdml)

    add_test(NAME BVHTest      COMMAND BVHTest ${PROJECT_SOURCE_DIR}/persistency/gdml/gdmls/trackML.gdml)
    add_test(NAME GeometryTest-Device-trackML COMMAND GeometryTest ${PROJECT_SOURCE_DIR}/persistency/gdml/gdmls/trackML.gdml)
    add_test(NAME GeometryTest-Device-cms2018 COMMAND GeometryTest ${PROJECT_SOURCE_DIR}/persistency/gdml/gdmls/cms2018.gdml)
  endif()
endif()

################################################################################
# - Shape Tester tests
set(TEST_EXECUTABLES_SHAPETESTER
  shape_tester/shape_testBox.cpp
  shape_tester/shape_testSExtru.cpp
  shape_tester/shape_testOrb.cpp
  shape_tester/shape_testSphere.cpp
  shape_tester/shape_testCone.cpp
  shape_tester/shape_testEllipticalCone.cpp
  shape_tester/shape_testTube.cpp
  shape_tester/shape_testEllipticalTube.cpp
  shape_tester/shape_testEllipsoid.cpp
  shape_tester/shape_testHype.cpp
  shape_tester/shape_testTrd.cpp
  shape_tester/shape_testTrapezoid.cpp
  shape_tester/shape_testTet.cpp
  shape_tester/shape_testParaboloid.cpp
  shape_tester/shape_testPolycone.cpp
  shape_tester/shape_testGenericPolycone.cpp
  shape_tester/shape_testGenTrap.cpp
  shape_tester/shape_testParallelepiped.cpp
  shape_tester/convention_testTube.cpp
  shape_tester/shape_testPolyhedron.cpp
  shape_tester/shape_testTorus2.cpp
  shape_tester/shape_testCutTube.cpp
  shape_tester/shape_testExtruded.cpp
  shape_tester/shape_testMultiUnion.cpp)

if(VECGEOM_ROOT)
  list(APPEND TEST_EXECUTABLES_SHAPETESTER
    shape_tester/shape_testFromROOTFile.cpp
    shape_tester/shape_debugFromROOTFile.cpp)
endif()

if(NOT VECGEOM_ENABLE_CUDA)
  list(APPEND TEST_EXECUTABLES_SHAPETESTER shape_tester/shape_testTessellated.cpp)
endif()

if(VECGEOM_TEST_BENCHMARK)
  build_executables("${TEST_EXECUTABLES_SHAPETESTER}")
endif()


if(VECGEOM_TEST_VALIDATION AND VECGEOM_ROOT)
  macro(add_cmsshapevalidation_test TESTNAME SHAPEFILE)
    add_test(NAME ${TESTNAME} COMMAND bash -c "${PROJECT_SOURCE_DIR}/test/scripts/RunRandomValidation ${PROJECT_BINARY_DIR}/BenchmarkShapeFromROOTFile  ${CMAKE_CURRENT_BINARY_DIR}/cms2015.root  ${PROJECT_SOURCE_DIR}/test/cmstestdata/${SHAPEFILE}" )
  endmacro()

  # Adding various shapes tests for nightlies
  add_cmsshapevalidation_test( tubevalidation cmstubes.txt )
  add_cmsshapevalidation_test( trapvalidation cmstraps.txt )
  add_cmsshapevalidation_test( polyconevalidation cmspolycones.txt )
  add_cmsshapevalidation_test( polyhedravalidation cmspolyhedra.txt )
  add_cmsshapevalidation_test( conevalidation cmscones.txt )
  add_cmsshapevalidation_test( boxvalidation cmsboxes.txt )
  #taken out due to problems: add_cmsshapevalidation_test( booleanvalidation cmsbooleans.txt )
  #taken out due to Issue-133: add_cmsshapevalidation_test( torusvalidation cmstori.txt )
endif()

=== test/benchmark/CMakeLists.txt ===
#define some benchmark executables
set(TEST_EXECUTABLES_BENCHMARK
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/SExtruBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ConcaveSExtruBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParaboloidBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParaboloidScriptBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParallelepipedBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/PolyhedronBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TubeBenchmark.cpp
#  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxMinusHollowTubeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxMinusHollowTubeBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxUnionHollowTubeBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxIntersectHollowTubeBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxUnionBoxBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/3LevelSubtractionBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TorusBenchmark2.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrapezoidBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrapezoidBenchmarkScript.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/OrbBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/SphereBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/HypeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TetBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrdBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ConeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/EllipticalTubeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/EllipticalConeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/EllipsoidBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/PolyconeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/GenericPolyconeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ScaledBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxScaledBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/GenTrapBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/CutTubeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TessellatedBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ExtrudedBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/MultiUnionBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/UnionFlatteningBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/globalbenchmarks/NavigationBenchmark.cpp
)

build_executables("${TEST_EXECUTABLES_BENCHMARK}")

if(VECGEOM_ENABLE_CUDA)
  target_link_libraries(NavigationBenchmark PUBLIC vecgeomcuda)
endif()

if(VECGEOM_GDML)
  build_executables(${PROJECT_SOURCE_DIR}/test/benchmark/TestNavIndex.cpp)
  target_link_libraries(TestNavIndex PUBLIC vgdml)
endif()

#define which ones should be run under ctest
set(THISCTESTS
  # TESTS MARKED # FAIL AND NEED ATTENTION
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/SExtruBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ConcaveSExtruBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParaboloidBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParaboloidScriptBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ParallelepipedBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/PolyhedronBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TubeBenchmark.cpp
# ${PROJECT_SOURCE_DIR}/test/benchmark/BoxMinusHollowTubeBenchmark_virtual.cpp
# ${PROJECT_SOURCE_DIR}/test/benchmark/BoxUnionHollowTubeBenchmark_virtual.cpp
# ${PROJECT_SOURCE_DIR}/test/benchmark/BoxIntersectHollowTubeBenchmark_virtual.cpp
# ${PROJECT_SOURCE_DIR}/test/benchmark/BoxUnionBoxBenchmark_virtual.cpp
# ${PROJECT_SOURCE_DIR}/test/benchmark/3LevelSubtractionBenchmark_virtual.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TorusBenchmark2.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrapezoidBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrapezoidBenchmarkScript.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/OrbBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/SphereBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/HypeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/TrdBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ConeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/GenTrapBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/ScaledBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/BoxScaledBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/CutTubeBenchmark.cpp
  ${PROJECT_SOURCE_DIR}/test/benchmark/PolyconeBenchmark.cpp
)

add_to_ctest("${CTESTS_BENCHMARK}")

=== debian/changelog ===
vecgeom (1.2.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.2.0+dfsg

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 11 May 2022 21:43:24 +0200

vecgeom (1.1.20+dfsg-2) unstable; urgency=medium

  * Add vecgeom-dev package again for annoing CMake build files
  * Use TARGET_ARCHITECTURE=x86-64 for Vc on amd64
  * Fix reproducibility via CMAKE_BUILD_RPATH_USE_ORIGIN=ON

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 07 Apr 2022 21:32:44 +0200

vecgeom (1.1.20+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.20+dfsg

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 01 Apr 2022 13:52:35 +0200

vecgeom (1.1.19+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.19+dfsg
  * Build with C++20 support for std::experimental::simd backend
  * Build with SSE2 on amd64
  * Build shared libraries

 -- Stephan Lachnit <stephanlachnit@debian.org>  Tue, 29 Mar 2022 15:27:00 +0200

vecgeom (1.1.18+dfsg-2) unstable; urgency=medium

  * Fix not compiling on anything except i386 and amd64

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 25 Feb 2022 15:47:56 +0100

=== debian/control ===
Source: vecgeom
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Stephan Lachnit <stephanlachnit@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libembree-dev [any-amd64],
 libxerces-c-dev,
 vc-dev [any-amd64 any-arm any-arm64 any-i386],
 veccore-dev,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/vecgeom
Vcs-Git: https://salsa.debian.org/science-team/vecgeom.git
Homepage: https://gitlab.cern.ch/VecGeom/VecGeom

Package: vecgeom-dev
Section: libdevel
Architecture: any
Multi-Arch: no
Depends:
 ${misc:Depends},
 libvecgeom-dev (= ${binary:Version}),
 libvgdml-dev (= ${binary:Version}),
 veccore-dev,
 vc-dev [any-amd64 any-arm any-arm64 any-i386],
 libxerces-c-dev,
 libembree-dev [any-amd64],
Description: geometry library for particle-detector simulation - development files
 VecGeom is a vectorized geometry modeller library with hit-detection features
 as needed by particle detector simulation at the LHC and beyond.
 .
 This package includes the development files for VecGeom.

Package: libvecgeom-dev
Section: libdevel
Architecture: any
Multi-Arch: no
Depends:
 ${misc:Depends},
 libvecgeom1.2 (= ${binary:Version}),
 veccore-dev,
 vc-dev [any-amd64 any-arm any-arm64 any-i386],
 libembree-dev [any-amd64],
Suggests:
 vecgeom-dev (= ${binary:Version}),
Breaks: vecgeom-dev (<< 1.1.19+dfsg-1)
Description: geometry library for particle-detector simulation - headers
 VecGeom is a vectorized geometry modeller library with hit-detection features
 as needed by particle detector simulation at the LHC and beyond.
 .
 This package includes the headers for libvecgeom.

Package: libvecgeom1.2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: geometry library for particle-detector simulation
 VecGeom is a vectorized geometry modeller library with hit-detection features
 as needed by particle detector simulation at the LHC and beyond.

Package: libvgdml-dev
Section: libdevel
Architecture: any
Multi-Arch: no
Depends:
 ${misc:Depends},
 libvgdml1.2 (= ${binary:Version}),
 libvecgeom-dev (= ${binary:Version}),
 libxerces-c-dev,
Suggests:
 vecgeom-dev (= ${binary:Version}),
Breaks: vecgeom-dev (<< 1.1.19+dfsg-1)
Description: GDML interoperability library for VecGeom - headers
 VecGeom is a vectorized geometry modeller library with hit-detection features
 as needed by particle detector simulation at the LHC and beyond.
 .
 This package includes the headers for libvgdml.

Package: libvgdml1.2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: GDML interoperability library for VecGeom
 VecGeom is a vectorized geometry modeller library with hit-detection features
 as needed by particle detector simulation at the LHC and beyond.
 .
 This package includes the GDML interoperability library for VecGeom.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Use Vc only on amd64, arm, arm64 and i386, else Scalar
ifneq (,$(filter $(DEB_TARGET_ARCH),amd64 arm arm64 i386))
	VECGEOM_BACKEND=Vc
	VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=none
else
	VECGEOM_BACKEND=Scalar
endif

# Use x86 VC and SSE2 only on amd64
ifneq (,$(filter $(DEB_TARGET_ARCH),amd64))
	VECGEOM_VECTOR=sse2
	VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=x86-64
else
	VECGEOM_VECTOR=empty
endif

# Use Embree only on any-amd64
ifneq (,$(filter $(DEB_TARGET_ARCH),amd64))
	VECGEOM_EMBREE=ON
else
	VECGEOM_EMBREE=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_CXX_STANDARD=20 \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_TESTING=OFF \
		-DVECGEOM_GDML=ON \
		-DVECGEOM_EMBREE=$(VECGEOM_EMBREE) \
		-DVECGEOM_VECTOR=$(VECGEOM_VECTOR) \
		-DVECGEOM_BACKEND=$(VECGEOM_BACKEND) $(VC_TARGET_ARCHITECTURE)

## vecgeom 1.2.1%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 include(ExternalProject)
 
 project(VecGeom
-  VERSION 1.2.0
+  VERSION 1.2.1
   DESCRIPTION "Vectorized geometry library for particle-detector simulation"
   HOMEPAGE_URL "https://gitlab.cern.ch/VecGeom/VecGeom"
   LANGUAGES C CXX)

## vecgeom 1.2.1+dfsg

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -2,12 +2,17 @@
 ## TESTING
 ################################################################################
 # Helper Macros/Functions
+
+add_definitions(-UNDEBUG) # ensure asserts are enabled in all tests
 
 macro(build_executables EXECUTABLES)
   foreach(EXECUTABLE ${EXECUTABLES})
     get_filename_component(TARGET_NAME ${EXECUTABLE} NAME_WE)
     add_executable(${TARGET_NAME} ${EXECUTABLE})
-    target_link_libraries(${TARGET_NAME} PUBLIC $<IF:$<BOOL:${VECGEOM_ENABLE_CUDA}>,vecgeomcuda_static,vecgeom>)
+    target_link_libraries(${TARGET_NAME} PUBLIC 
+      $<IF:$<BOOL:${VECGEOM_ENABLE_CUDA}>,vecgeomcuda_static,vecgeom>
+      $<$<BOOL:${VECGEOM_TEST_BENCHMARK}>:VecGeomBenchmark>
+      $<$<BOOL:${VECGEOM_ROOT}>:VecGeomUtilities>)
   endforeach()
 endmacro()
 
@@ -42,15 +47,36 @@
 # Download data if required
 message(STATUS "Checking data files required for tests")
 if(VECGEOM_ROOT)
-  download_if_not_installed("https://cernbox.cern.ch/index.php/s/pn2UkCtloi7i0xy/download"
+  download_if_not_installed("https://cern.ch/geant4-data/geometry/detectors/cms2015.root"
     "cms2015.root"
     "${CMAKE_CURRENT_BINARY_DIR}"
     "fb3ede867532b372c5e6f7138d00c07e")
-  download_if_not_installed("https://cernbox.cern.ch/index.php/s/dTChF8iKEUQHMxo/download"
+  download_if_not_installed("https://cern.ch/geant4-data/geometry/detectors/ExN03.root"
     "ExN03.root"
     "${CMAKE_CURRENT_BINARY_DIR}"
     "b6b0cfdd5035117171bfe1b7f1f40c3f")
 endif()
+
+################################################################################
+# Define Testing libraries
+################################################################################
+if(VECGEOM_TEST_BENCHMARK)
+  add_subdirectory(VecGeomBenchmark)
+endif()
+
+if(VECGEOM_ROOT)
+  add_library(VecGeomUtilities STATIC 
+    utilities/ShapeDebugger.cpp 
+    utilities/ShapeDebugger.h
+    utilities/Visualizer.cpp
+    utilities/Visualizer.h)
+  target_include_directories(VecGeomUtilities PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
+  target_link_libraries(VecGeomUtilities 
+    PUBLIC vecgeom ROOT::Graf3d 
+    PRIVATE ROOT::Core ROOT::Geom ROOT::Gpad)
+endif()
+
+
 ################################################################################
 # Define executables
 ################################################################################
@@ -134,8 +160,8 @@
     globalbenchmarks/TraceTrack.cpp
     globalbenchmarks/XRayBenchmarkFromROOTFile.cpp
     # ???
-    ${PROJECT_SOURCE_DIR}/services/NavigationSpecializerTest.cpp
-    ${PROJECT_SOURCE_DIR}/services/LibraryGenerator.cpp)
+    services/NavigationSpecializerTest.cpp
+    services/LibraryGenerator.cpp)
 
   if(VECGEOM_TEST_BENCHMARK)
     list(APPEND TEST_EXECUTABLES_ROOT
@@ -220,7 +246,9 @@
   unit_tests/TestTorus2.cpp
   unit_tests/TestParaboloid.cpp
   unit_tests/TestReducedPolycone.cpp
-  unit_tests/TestUtils3D.cpp)
+  unit_tests/TestUtils3D.cpp
+  unit_tests/TestMarchingCubes.cpp
+  unit_tests/TestVECGEOM-601.cpp)
 
 if(NOT VECGEOM_ENABLE_CUDA)
   list(APPEND TEST_EXECUTABLES_SHAPES
@@ -244,6 +272,7 @@
 add_test(NAME TestTrap COMMAND TestTrap)
 add_test(NAME TestTrd COMMAND TestTrd)
 add_test(NAME TestTube COMMAND TestTube)
+add_test(NAME TestVECGEOM-601 COMMAND TestVECGEOM-601)
 if(NOT VECGEOM_ENABLE_CUDA)
   add_test(NAME TestTessellated COMMAND TestTessellated)
 endif()
@@ -272,6 +301,13 @@
 
 ################################################################################
 # - Shape Tester tests
+add_library(VecGeomShapeTester STATIC 
+  shape_tester/ShapeTester.h 
+  shape_tester/ShapeTester.cpp #includes ConventionChecker.cpp ...
+  )
+target_include_directories(VecGeomShapeTester PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/shaper_tester")
+target_link_libraries(VecGeomShapeTester PUBLIC vecgeom $<$<BOOL:${VECGEOM_ROOT}>:VecGeomUtilities>)
+
 set(TEST_EXECUTABLES_SHAPETESTER
   shape_tester/shape_testBox.cpp
   shape_tester/shape_testSExtru.cpp
@@ -305,26 +341,3 @@
 endif()
 
 if(NOT VECGEOM_ENABLE_CUDA)
-  list(APPEND TEST_EXECUTABLES_SHAPETESTER shape_tester/shape_testTessellated.cpp)
-endif()
-
-if(VECGEOM_TEST_BENCHMARK)
-  build_executables("${TEST_EXECUTABLES_SHAPETESTER}")
-endif()
-
-
-if(VECGEOM_TEST_VALIDATION AND VECGEOM_ROOT)
-  macro(add_cmsshapevalidation_test TESTNAME SHAPEFILE)
-    add_test(NAME ${TESTNAME} COMMAND bash -c "${PROJECT_SOURCE_DIR}/test/scripts/RunRandomValidation ${PROJECT_BINARY_DIR}/BenchmarkShapeFromROOTFile  ${CMAKE_CURRENT_BINARY_DIR}/cms2015.root  ${PROJECT_SOURCE_DIR}/test/cmstestdata/${SHAPEFILE}" )
-  endmacro()
-
-  # Adding various shapes tests for nightlies
-  add_cmsshapevalidation_test( tubevalidation cmstubes.txt )
-  add_cmsshapevalidation_test( trapvalidation cmstraps.txt )
-  add_cmsshapevalidation_test( polyconevalidation cmspolycones.txt )
-  add_cmsshapevalidation_test( polyhedravalidation cmspolyhedra.txt )
-  add_cmsshapevalidation_test( conevalidation cmscones.txt )
-  add_cmsshapevalidation_test( boxvalidation cmsboxes.txt )
-  #taken out due to problems: add_cmsshapevalidation_test( booleanvalidation cmsbooleans.txt )
-  #taken out due to Issue-133: add_cmsshapevalidation_test( torusvalidation cmstori.txt )
-endif()

=== persistency/gdml/CMakeLists.txt ===
#    \file CMakeLists.txt
#    \brief builds and tests a library for interoperation of VecGeom with GDML
#
#    \authors Author:  Dmitry Savin
#
#    \license Distributed under the Apache license 2.0

# Find XercesC 
find_package(XercesC REQUIRED)

add_subdirectory(source)

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== test/VecGeomBenchmark/CMakeLists.txt ===
add_library(VecGeomBenchmark STATIC
  Benchmarker.h
  Benchmarker.cpp
  BenchmarkResult.h
  BenchmarkResult.cpp
  NavigationBenchmarker.h
  NavigationBenchmarker.cpp
  VolumePointers.h
  VolumePointers.cpp
  $<$<BOOL:${VECGEOM_ENABLE_CUDA}>:
    Benchmarker.cu;
    NavigationBenchmarker.cu>
  )

target_include_directories(VecGeomBenchmark PUBLIC ${PROJECT_SOURCE_DIR}/test)
target_link_libraries(VecGeomBenchmark PUBLIC vecgeom)

=== test/benchmark/CMakeLists.txt ===
--- 
+++ 
@@ -47,6 +47,9 @@
 
 if(VECGEOM_GDML)
   build_executables(${PROJECT_SOURCE_DIR}/test/benchmark/TestNavIndex.cpp)
+  if(VECGEOM_ENABLE_CUDA)
+    target_sources(TestNavIndex PRIVATE TestNavIndex.cu)
+  endif()
   target_link_libraries(TestNavIndex PUBLIC vgdml)
 endif()

=== persistency/gdml/source/CMakeLists.txt ===
#    \file CMakeLists.txt
#    \brief builds a library for interoperation of VecGeom with GDML
#
#    \authors Author:  Dmitry Savin
#
#    \license Distributed under the Apache license 2.0

add_library(vgdml
  include/Auxiliary.h
  include/Backend.h
  include/Frontend.h
  include/Helper.h
  include/MaterialInfo.h
  include/RegionInfo.h
  include/Middleware.h
  include/ReflFactory.h
  src/Backend.cpp
  src/Frontend.cpp
  src/Helper.cpp
  src/Middleware.cpp
  src/ReflFactory.cpp
)

target_include_directories(vgdml PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)
target_link_libraries(vgdml PUBLIC XercesC::XercesC vecgeom)

if(VECGEOM_GDMLDEBUG)
  # Only used in Middleware.cpp, and to set a constant
  target_compile_definitions(vgdml PRIVATE GDMLDEBUG)
endif()

install(TARGETS vgdml EXPORT VecGeomTargets DESTINATION "${CMAKE_INSTALL_LIBDIR}")
install(DIRECTORY include/ DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/VecGeom/gdml"
  FILES_MATCHING PATTERN "*.h"
)

=== persistency/gdml/test/CMakeLists.txt ===
#    \file CMakeLists.txt
#    \brief tests the library for interoperation of VecGeom with GDML
#
#    \authors Author:  Dmitry Savin
#
#    \license Distributed under the Apache license 2.0
# Executable for Backend/Frontend/Middleware/Schema types
foreach(_vgdml_test TestXercesBackend TestXercesFrontend TestXercesMiddleware ReadMiddlewareData
                    TestVGDMLAuxiliary TestVGDMLNavigation TestVGDMLVolumeAuxiliaryInfo)
  add_executable(${_vgdml_test} ${_vgdml_test}/${_vgdml_test}.cpp)
  target_link_libraries(${_vgdml_test} PUBLIC vgdml $<IF:$<BOOL:${VECGEOM_ENABLE_CUDA}>,vecgeomcuda_static,vecgeom>)
endforeach()

# Tests of VGDML's types for the GDML schema and translations
add_test(NAME TestVGDMLAuxiliary COMMAND TestVGDMLAuxiliary)
add_test(NAME TestVGDMLVolumeAuxiliaryInfo COMMAND TestVGDMLVolumeAuxiliaryInfo "${CMAKE_CURRENT_SOURCE_DIR}/../gdmls/auxiliary.gdml" )

# Add tests for each type with needed input GDML file
# - Backend
file(GLOB GDMLS ${CMAKE_CURRENT_SOURCE_DIR}/../gdmls/*.gdml)
foreach(GDML ${GDMLS})
  get_filename_component(BASENAMEGDML ${GDML} NAME)
  add_test(NAME TestXercesBackend-${BASENAMEGDML} COMMAND TestXercesBackend ${GDML})
endforeach()

# - Middleware
foreach(BASENAMEGDML oneOrb oneSphere oneTorus oneBox oneTube oneConeSegment oneParallelepiped oneTrapezoid oneParaboloid oneGeneralTrapezoid oneHyperbolicTube oneCutTube aConstant twoBoxes aPosition aRotation solidIntersection solidSubtraction solidUnion onePolycone onePolyhedron cms2018)
  set(GDMLFILE ${CMAKE_CURRENT_SOURCE_DIR}/../gdmls/${BASENAMEGDML}.gdml)
  add_test(NAME TestXercesMiddleware-${BASENAMEGDML} COMMAND TestXercesMiddleware ${GDMLFILE})
endforeach()

# - Navigation tests using GDML input file

foreach(NAVIGATOR SimpleABBoxNavigator HybridNavigator BVHNavigator)
  foreach(GDML trackML cms2018)
    set(GDML_FILE ${CMAKE_CURRENT_SOURCE_DIR}/../gdmls/${GDML}.gdml)
    add_test(NAME Test${NAVIGATOR}-${GDML}
      COMMAND TestVGDMLNavigation -i 10 -n ${NAVIGATOR} ${GDML_FILE})
  endforeach()
endforeach()

=== debian/changelog ===
vecgeom (1.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.2.1+dfsg

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 08 Dec 2022 14:03:05 +0100

vecgeom (1.2.0+dfsg-3) unstable; urgency=medium

  * Fix SSE4.2 dependence on non-amd64 systems

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 09 Nov 2022 23:16:06 +0100

vecgeom (1.2.0+dfsg-2) unstable; urgency=medium

  * Revert back to C++17
  * Add libtbb-dev to b-d to fix temporary FTBFS (original bug is in src:embree)
  * Build with SSE4.2 on amd64

 -- Stephan Lachnit <stephanlachnit@debian.org>  Sat, 10 Sep 2022 13:43:42 +0200

=== debian/control ===
--- 
+++ 
@@ -59,6 +59,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+ sse4.2-support [any-amd64],
 Description: geometry library for particle-detector simulation
  VecGeom is a vectorized geometry modeller library with hit-detection features
  as needed by particle detector simulation at the LHC and beyond.
@@ -87,6 +88,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+ sse4.2-support [any-amd64],
 Description: GDML interoperability library for VecGeom
  VecGeom is a vectorized geometry modeller library with hit-detection features
  as needed by particle detector simulation at the LHC and beyond.

=== debian/rules ===
--- 
+++ 
@@ -10,10 +10,10 @@
 	VECGEOM_BACKEND=Scalar
 endif
 
-# Use x86 VC and SSE2 only on amd64
+# Use x86 VC and SSE4.2 only on amd64
 ifneq (,$(filter $(DEB_TARGET_ARCH),amd64))
-	VECGEOM_VECTOR=sse2
-	VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=x86-64
+	VECGEOM_VECTOR=sse4.2
+	VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=x86-64-v2
 else
 	VECGEOM_VECTOR=empty
 endif
@@ -30,7 +30,6 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DCMAKE_CXX_STANDARD=20 \
 		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
 		-DBUILD_SHARED_LIBS=ON \
 		-DBUILD_TESTING=OFF \
